<template>
  <single-pane capt="Пользователи">
    <ob-table
      ref="usersTable"
      :remote-opt="api.adminPanel.users.getUsers"
      :columns="gridColumns"
      :functional-panel="true"
      :show-add-button="true"
      :is-functional-sort="false"
      :is-functional-group="false"
      @select="openUserPopup"
      @add="openUserPopup()"
    />

    <ob-modal
      ref="userModal"
      :title-second="selectedUser.uuid ? 'редактирование' : 'добавление'"
      title="Пользователь"
      :data-grid="$refs.usersGrid"
      :is-show-controls="false"
      size="medium"
    >
      <UserModal
        @submitted="onSubmittedForm"
        :data-source="selectedUser"
      />
    </ob-modal>
<!--    <Chat/>-->
  </single-pane>
</template>

<script>
  import SinglePane from "common-components/src/obComponents/obSinglePanels";
  import itemMixin from '@/mixins/edit-item';
  import ObModal from "common-components/src/obComponents/obModal";
  import ObTable from "common-components/src/obComponents/obTable";
  import UserModal from './modal/UserModal.vue';
  // import Chat from '@/components/chat';
  import api from '@/api';
  import moment from "moment";
  import { mapGetters } from 'vuex'
  import masker from 'common-components/src/obComponents/obMask/utils/masker'

  export default {
    name: 'Users',
    components: {
      UserModal,
      SinglePane,
      ObTable,
      ObModal
      // Chat
    },
    mixins: {
      itemMixin
    },
    data () {
      return {
        gridColumns: [
          {
            title: 'ФИО',
            key: 'phio',
            html: (user) => user.is_active ?
              `${user.last_name || ''} ${user.first_name || ''} ${user.patronymic || ''}` :
              `<s class="not-active">${user.last_name || ''} ${user.first_name || ''} ${user.patronymic || ''}</s>`
          },
          {
            title: 'Роль пользователя',
            key: 'roleName',
            html: (user) => user.is_active ?
              `${user.worker_roles.map(role => role.title).join(', ')}` :
              `<s class="not-active">${user.worker_roles.map(role => role.title).join(', ')}</s>`
          },
          {
            title: 'Телефон',
            key: 'phone',
            width: 200,
            html: ({is_active, phone}) => {
              phone = phone && phone.length > 10 ? phone.substr(1, 10) : phone
              phone = masker(phone, '+7 (999) 999-9999')
              return is_active ? `${phone}` : `<span class="not-active">${phone}</span>`
            }
          },
          {
            title: 'E-mail',
            key: 'email',
            html: ({is_active, email}) => is_active ? `${email}` : `<span class="not-active">${email}</span>`
          },
          {
            title: 'кол-во организаций',
            key: 'organization',
            html: () => 3
          },
          {
            title: 'Статус',
            key: 'status',
            html: ({is_active}) => is_active ? 'Активна' : `<span class="not-active">Неактивна</span>`
          },
          {
            title: 'дата изменения',
            key: 'updated_at',
            html: ({updated_at, is_active}) => updated_at ?
              is_active ?
                moment(updated_at).format('DD.MM.YYYY') :
                `<span class="not-active">${moment(updated_at).format('DD.MM.YYYY')}</span>` :
              ''
          }
        ],
        selectedUser: {},
        api
      }
    },
    computed: {
      ...mapGetters({
        isClicar: 'user/isClicar'
      })
    },
    methods: {
      async openUserPopup (data = {}) {
        let organizations = []

        if (data.uuid) {
          organizations = await this.getOrgs(data.uuid)
        }

        // https://oboz.myjetbrains.com/youtrack/issue/SB-1687
        if (data.phone?.length > 10 && data.phone.startsWith('8')) {
          data.phone = data.phone.substring(1)
        }

        this.selectedUser = {
          ...data,
          organizations,
          worker_roles: data.worker_roles ? data.worker_roles.map(item => item.uuid) : []
        }

        this.$refs.userModal.open()
      },
      openAdd () {
        this.$refs.userModal.open()
      },
      async getOrgs (uuid) {
        if (!uuid || !this.isClicar) {
          return []
        }

        try {
          const response = await api.adminPanel.users.getUserOrgs(uuid)

          return response.responseOrganizationList?.organizationUserList?.map(item => item.uuid) || []
        } catch (e) {
          this.$notification({
            type: 'system_notification_error',
            message: 'Ошибка загрузки организаций'
          })
        }
      },
      onSubmittedForm () {
        this.$refs.userModal.close()
        setTimeout(() => {
          this.$refs.usersTable.loadData()
        }, 1000)
      }
    }
  }
</script>

<style scoped lang="scss">
  .not-active {
    color: $gray-slate;
  }
</style>